<%

# $Header: /u/cvsroot/nsd-modules/dqd_threadpool/examples/book-cache/www/lookup.adp,v 1.2 2000/11/23 01:14:36 mayoff Exp $

# See LICENSE for copyright, license, and disclaimers.

    set form [ns_getform]
    if {$form != ""} {
	set isbn [ns_set get $form isbn]
    }
    if {$form == "" || $isbn == ""} {
	ns_returnredirect /
	ns_adp_abort
    }
    regsub -all -- {-} $isbn {} isbn
%><html>
    <head>
	<title>
	    Results for <%= $isbn %>
	</title>
    </head>
    <body>
	<h2>Results for <%= $isbn %></h2>
	<a href='/'>Back to ISBN entry screen.</a>
	<hr>

	<ul>
<%
    ns_adp_stream

    set jobs {}

    foreach bookstore {amazon bn 1bookstreet wordsworth} {
	set key "$bookstore.$isbn"

	if {[ns_cache get bookprices $key result]} {
	    set bookstore [ns_quotehtml [lindex $result 0]]
	    set link [lindex $result 1]
	    set title [ns_quotehtml [lindex $result 2]]
	    set price [lindex $result 3]

	    ns_adp_puts "<li>$price for \"$title\" at <a href='$link'>$bookstore</a><br>\n"
	} else {
	    lappend jobs [dqd_threadpool create bookpool \
		[list ns_cache eval bookprices $key \
		    [list "${bookstore}_lookup" $isbn]]]
	}
    }

    while {[llength $jobs] > 0} {
	set pair [dqd_threadpool wait bookpool $jobs]

	set finished [lindex $pair 0]
	set remaining [lindex $pair 1]

	foreach job $finished {
	    set pair [dqd_threadpool get bookpool $job]
	    set code [lindex $pair 0]
	    set result [lindex $pair 1]

	    set bookstore [ns_quotehtml [lindex $result 0]]
	    set link [lindex $result 1]

	    if {$code == 1} {
		set problem [ns_quotehtml [lindex $result 2]]
		ns_adp_puts "<li>Could not determine price at <a href='$link'>$bookstore</a>: $problem<br>\n"
	    } else {
		set title [ns_quotehtml [lindex $result 2]]
		set price [lindex $result 3]
		ns_adp_puts "<li>$price for \"$title\" at <a href='$link'>$bookstore</a><br>\n"
	    }
	}

	set jobs $remaining
    }
%>
	</ul>
    </body>
</html>

